package mocks

// Code generated by http://github.com/gojuno/minimock (dev). DO NOT EDIT.

//go:generate minimock -i github.com/dmitriygnatenko/internal/interfaces.IArticleTagRepository -o ./mocks/i_article_tag_repository_minimock.go -n IArticleTagRepositoryMock

import (
	"context"
	"sync"
	mm_atomic "sync/atomic"
	mm_time "time"

	"github.com/gojuno/minimock/v3"
)

// IArticleTagRepositoryMock implements interfaces.IArticleTagRepository
type IArticleTagRepositoryMock struct {
	t minimock.Tester

	funcAdd          func(ctx context.Context, articleID int, tagIDs []int) (err error)
	inspectFuncAdd   func(ctx context.Context, articleID int, tagIDs []int)
	afterAddCounter  uint64
	beforeAddCounter uint64
	AddMock          mIArticleTagRepositoryMockAdd

	funcDelete          func(ctx context.Context, articleID int, tagIDs []int) (err error)
	inspectFuncDelete   func(ctx context.Context, articleID int, tagIDs []int)
	afterDeleteCounter  uint64
	beforeDeleteCounter uint64
	DeleteMock          mIArticleTagRepositoryMockDelete

	funcDeleteByArticleID          func(ctx context.Context, articleID int) (err error)
	inspectFuncDeleteByArticleID   func(ctx context.Context, articleID int)
	afterDeleteByArticleIDCounter  uint64
	beforeDeleteByArticleIDCounter uint64
	DeleteByArticleIDMock          mIArticleTagRepositoryMockDeleteByArticleID
}

// NewIArticleTagRepositoryMock returns a mock for interfaces.IArticleTagRepository
func NewIArticleTagRepositoryMock(t minimock.Tester) *IArticleTagRepositoryMock {
	m := &IArticleTagRepositoryMock{t: t}
	if controller, ok := t.(minimock.MockController); ok {
		controller.RegisterMocker(m)
	}

	m.AddMock = mIArticleTagRepositoryMockAdd{mock: m}
	m.AddMock.callArgs = []*IArticleTagRepositoryMockAddParams{}

	m.DeleteMock = mIArticleTagRepositoryMockDelete{mock: m}
	m.DeleteMock.callArgs = []*IArticleTagRepositoryMockDeleteParams{}

	m.DeleteByArticleIDMock = mIArticleTagRepositoryMockDeleteByArticleID{mock: m}
	m.DeleteByArticleIDMock.callArgs = []*IArticleTagRepositoryMockDeleteByArticleIDParams{}

	return m
}

type mIArticleTagRepositoryMockAdd struct {
	mock               *IArticleTagRepositoryMock
	defaultExpectation *IArticleTagRepositoryMockAddExpectation
	expectations       []*IArticleTagRepositoryMockAddExpectation

	callArgs []*IArticleTagRepositoryMockAddParams
	mutex    sync.RWMutex
}

// IArticleTagRepositoryMockAddExpectation specifies expectation struct of the IArticleTagRepository.Add
type IArticleTagRepositoryMockAddExpectation struct {
	mock    *IArticleTagRepositoryMock
	params  *IArticleTagRepositoryMockAddParams
	results *IArticleTagRepositoryMockAddResults
	Counter uint64
}

// IArticleTagRepositoryMockAddParams contains parameters of the IArticleTagRepository.Add
type IArticleTagRepositoryMockAddParams struct {
	ctx       context.Context
	articleID int
	tagIDs    []int
}

// IArticleTagRepositoryMockAddResults contains results of the IArticleTagRepository.Add
type IArticleTagRepositoryMockAddResults struct {
	err error
}

// Expect sets up expected params for IArticleTagRepository.Add
func (mmAdd *mIArticleTagRepositoryMockAdd) Expect(ctx context.Context, articleID int, tagIDs []int) *mIArticleTagRepositoryMockAdd {
	if mmAdd.mock.funcAdd != nil {
		mmAdd.mock.t.Fatalf("IArticleTagRepositoryMock.Add mock is already set by Set")
	}

	if mmAdd.defaultExpectation == nil {
		mmAdd.defaultExpectation = &IArticleTagRepositoryMockAddExpectation{}
	}

	mmAdd.defaultExpectation.params = &IArticleTagRepositoryMockAddParams{ctx, articleID, tagIDs}
	for _, e := range mmAdd.expectations {
		if minimock.Equal(e.params, mmAdd.defaultExpectation.params) {
			mmAdd.mock.t.Fatalf("Expectation set by When has same params: %#v", *mmAdd.defaultExpectation.params)
		}
	}

	return mmAdd
}

// Inspect accepts an inspector function that has same arguments as the IArticleTagRepository.Add
func (mmAdd *mIArticleTagRepositoryMockAdd) Inspect(f func(ctx context.Context, articleID int, tagIDs []int)) *mIArticleTagRepositoryMockAdd {
	if mmAdd.mock.inspectFuncAdd != nil {
		mmAdd.mock.t.Fatalf("Inspect function is already set for IArticleTagRepositoryMock.Add")
	}

	mmAdd.mock.inspectFuncAdd = f

	return mmAdd
}

// Return sets up results that will be returned by IArticleTagRepository.Add
func (mmAdd *mIArticleTagRepositoryMockAdd) Return(err error) *IArticleTagRepositoryMock {
	if mmAdd.mock.funcAdd != nil {
		mmAdd.mock.t.Fatalf("IArticleTagRepositoryMock.Add mock is already set by Set")
	}

	if mmAdd.defaultExpectation == nil {
		mmAdd.defaultExpectation = &IArticleTagRepositoryMockAddExpectation{mock: mmAdd.mock}
	}
	mmAdd.defaultExpectation.results = &IArticleTagRepositoryMockAddResults{err}
	return mmAdd.mock
}

//Set uses given function f to mock the IArticleTagRepository.Add method
func (mmAdd *mIArticleTagRepositoryMockAdd) Set(f func(ctx context.Context, articleID int, tagIDs []int) (err error)) *IArticleTagRepositoryMock {
	if mmAdd.defaultExpectation != nil {
		mmAdd.mock.t.Fatalf("Default expectation is already set for the IArticleTagRepository.Add method")
	}

	if len(mmAdd.expectations) > 0 {
		mmAdd.mock.t.Fatalf("Some expectations are already set for the IArticleTagRepository.Add method")
	}

	mmAdd.mock.funcAdd = f
	return mmAdd.mock
}

// When sets expectation for the IArticleTagRepository.Add which will trigger the result defined by the following
// Then helper
func (mmAdd *mIArticleTagRepositoryMockAdd) When(ctx context.Context, articleID int, tagIDs []int) *IArticleTagRepositoryMockAddExpectation {
	if mmAdd.mock.funcAdd != nil {
		mmAdd.mock.t.Fatalf("IArticleTagRepositoryMock.Add mock is already set by Set")
	}

	expectation := &IArticleTagRepositoryMockAddExpectation{
		mock:   mmAdd.mock,
		params: &IArticleTagRepositoryMockAddParams{ctx, articleID, tagIDs},
	}
	mmAdd.expectations = append(mmAdd.expectations, expectation)
	return expectation
}

// Then sets up IArticleTagRepository.Add return parameters for the expectation previously defined by the When method
func (e *IArticleTagRepositoryMockAddExpectation) Then(err error) *IArticleTagRepositoryMock {
	e.results = &IArticleTagRepositoryMockAddResults{err}
	return e.mock
}

// Add implements interfaces.IArticleTagRepository
func (mmAdd *IArticleTagRepositoryMock) Add(ctx context.Context, articleID int, tagIDs []int) (err error) {
	mm_atomic.AddUint64(&mmAdd.beforeAddCounter, 1)
	defer mm_atomic.AddUint64(&mmAdd.afterAddCounter, 1)

	if mmAdd.inspectFuncAdd != nil {
		mmAdd.inspectFuncAdd(ctx, articleID, tagIDs)
	}

	mm_params := &IArticleTagRepositoryMockAddParams{ctx, articleID, tagIDs}

	// Record call args
	mmAdd.AddMock.mutex.Lock()
	mmAdd.AddMock.callArgs = append(mmAdd.AddMock.callArgs, mm_params)
	mmAdd.AddMock.mutex.Unlock()

	for _, e := range mmAdd.AddMock.expectations {
		if minimock.Equal(e.params, mm_params) {
			mm_atomic.AddUint64(&e.Counter, 1)
			return e.results.err
		}
	}

	if mmAdd.AddMock.defaultExpectation != nil {
		mm_atomic.AddUint64(&mmAdd.AddMock.defaultExpectation.Counter, 1)
		mm_want := mmAdd.AddMock.defaultExpectation.params
		mm_got := IArticleTagRepositoryMockAddParams{ctx, articleID, tagIDs}
		if mm_want != nil && !minimock.Equal(*mm_want, mm_got) {
			mmAdd.t.Errorf("IArticleTagRepositoryMock.Add got unexpected parameters, want: %#v, got: %#v%s\n", *mm_want, mm_got, minimock.Diff(*mm_want, mm_got))
		}

		mm_results := mmAdd.AddMock.defaultExpectation.results
		if mm_results == nil {
			mmAdd.t.Fatal("No results are set for the IArticleTagRepositoryMock.Add")
		}
		return (*mm_results).err
	}
	if mmAdd.funcAdd != nil {
		return mmAdd.funcAdd(ctx, articleID, tagIDs)
	}
	mmAdd.t.Fatalf("Unexpected call to IArticleTagRepositoryMock.Add. %v %v %v", ctx, articleID, tagIDs)
	return
}

// AddAfterCounter returns a count of finished IArticleTagRepositoryMock.Add invocations
func (mmAdd *IArticleTagRepositoryMock) AddAfterCounter() uint64 {
	return mm_atomic.LoadUint64(&mmAdd.afterAddCounter)
}

// AddBeforeCounter returns a count of IArticleTagRepositoryMock.Add invocations
func (mmAdd *IArticleTagRepositoryMock) AddBeforeCounter() uint64 {
	return mm_atomic.LoadUint64(&mmAdd.beforeAddCounter)
}

// Calls returns a list of arguments used in each call to IArticleTagRepositoryMock.Add.
// The list is in the same order as the calls were made (i.e. recent calls have a higher index)
func (mmAdd *mIArticleTagRepositoryMockAdd) Calls() []*IArticleTagRepositoryMockAddParams {
	mmAdd.mutex.RLock()

	argCopy := make([]*IArticleTagRepositoryMockAddParams, len(mmAdd.callArgs))
	copy(argCopy, mmAdd.callArgs)

	mmAdd.mutex.RUnlock()

	return argCopy
}

// MinimockAddDone returns true if the count of the Add invocations corresponds
// the number of defined expectations
func (m *IArticleTagRepositoryMock) MinimockAddDone() bool {
	for _, e := range m.AddMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			return false
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.AddMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterAddCounter) < 1 {
		return false
	}
	// if func was set then invocations count should be greater than zero
	if m.funcAdd != nil && mm_atomic.LoadUint64(&m.afterAddCounter) < 1 {
		return false
	}
	return true
}

// MinimockAddInspect logs each unmet expectation
func (m *IArticleTagRepositoryMock) MinimockAddInspect() {
	for _, e := range m.AddMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			m.t.Errorf("Expected call to IArticleTagRepositoryMock.Add with params: %#v", *e.params)
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.AddMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterAddCounter) < 1 {
		if m.AddMock.defaultExpectation.params == nil {
			m.t.Error("Expected call to IArticleTagRepositoryMock.Add")
		} else {
			m.t.Errorf("Expected call to IArticleTagRepositoryMock.Add with params: %#v", *m.AddMock.defaultExpectation.params)
		}
	}
	// if func was set then invocations count should be greater than zero
	if m.funcAdd != nil && mm_atomic.LoadUint64(&m.afterAddCounter) < 1 {
		m.t.Error("Expected call to IArticleTagRepositoryMock.Add")
	}
}

type mIArticleTagRepositoryMockDelete struct {
	mock               *IArticleTagRepositoryMock
	defaultExpectation *IArticleTagRepositoryMockDeleteExpectation
	expectations       []*IArticleTagRepositoryMockDeleteExpectation

	callArgs []*IArticleTagRepositoryMockDeleteParams
	mutex    sync.RWMutex
}

// IArticleTagRepositoryMockDeleteExpectation specifies expectation struct of the IArticleTagRepository.Delete
type IArticleTagRepositoryMockDeleteExpectation struct {
	mock    *IArticleTagRepositoryMock
	params  *IArticleTagRepositoryMockDeleteParams
	results *IArticleTagRepositoryMockDeleteResults
	Counter uint64
}

// IArticleTagRepositoryMockDeleteParams contains parameters of the IArticleTagRepository.Delete
type IArticleTagRepositoryMockDeleteParams struct {
	ctx       context.Context
	articleID int
	tagIDs    []int
}

// IArticleTagRepositoryMockDeleteResults contains results of the IArticleTagRepository.Delete
type IArticleTagRepositoryMockDeleteResults struct {
	err error
}

// Expect sets up expected params for IArticleTagRepository.Delete
func (mmDelete *mIArticleTagRepositoryMockDelete) Expect(ctx context.Context, articleID int, tagIDs []int) *mIArticleTagRepositoryMockDelete {
	if mmDelete.mock.funcDelete != nil {
		mmDelete.mock.t.Fatalf("IArticleTagRepositoryMock.Delete mock is already set by Set")
	}

	if mmDelete.defaultExpectation == nil {
		mmDelete.defaultExpectation = &IArticleTagRepositoryMockDeleteExpectation{}
	}

	mmDelete.defaultExpectation.params = &IArticleTagRepositoryMockDeleteParams{ctx, articleID, tagIDs}
	for _, e := range mmDelete.expectations {
		if minimock.Equal(e.params, mmDelete.defaultExpectation.params) {
			mmDelete.mock.t.Fatalf("Expectation set by When has same params: %#v", *mmDelete.defaultExpectation.params)
		}
	}

	return mmDelete
}

// Inspect accepts an inspector function that has same arguments as the IArticleTagRepository.Delete
func (mmDelete *mIArticleTagRepositoryMockDelete) Inspect(f func(ctx context.Context, articleID int, tagIDs []int)) *mIArticleTagRepositoryMockDelete {
	if mmDelete.mock.inspectFuncDelete != nil {
		mmDelete.mock.t.Fatalf("Inspect function is already set for IArticleTagRepositoryMock.Delete")
	}

	mmDelete.mock.inspectFuncDelete = f

	return mmDelete
}

// Return sets up results that will be returned by IArticleTagRepository.Delete
func (mmDelete *mIArticleTagRepositoryMockDelete) Return(err error) *IArticleTagRepositoryMock {
	if mmDelete.mock.funcDelete != nil {
		mmDelete.mock.t.Fatalf("IArticleTagRepositoryMock.Delete mock is already set by Set")
	}

	if mmDelete.defaultExpectation == nil {
		mmDelete.defaultExpectation = &IArticleTagRepositoryMockDeleteExpectation{mock: mmDelete.mock}
	}
	mmDelete.defaultExpectation.results = &IArticleTagRepositoryMockDeleteResults{err}
	return mmDelete.mock
}

//Set uses given function f to mock the IArticleTagRepository.Delete method
func (mmDelete *mIArticleTagRepositoryMockDelete) Set(f func(ctx context.Context, articleID int, tagIDs []int) (err error)) *IArticleTagRepositoryMock {
	if mmDelete.defaultExpectation != nil {
		mmDelete.mock.t.Fatalf("Default expectation is already set for the IArticleTagRepository.Delete method")
	}

	if len(mmDelete.expectations) > 0 {
		mmDelete.mock.t.Fatalf("Some expectations are already set for the IArticleTagRepository.Delete method")
	}

	mmDelete.mock.funcDelete = f
	return mmDelete.mock
}

// When sets expectation for the IArticleTagRepository.Delete which will trigger the result defined by the following
// Then helper
func (mmDelete *mIArticleTagRepositoryMockDelete) When(ctx context.Context, articleID int, tagIDs []int) *IArticleTagRepositoryMockDeleteExpectation {
	if mmDelete.mock.funcDelete != nil {
		mmDelete.mock.t.Fatalf("IArticleTagRepositoryMock.Delete mock is already set by Set")
	}

	expectation := &IArticleTagRepositoryMockDeleteExpectation{
		mock:   mmDelete.mock,
		params: &IArticleTagRepositoryMockDeleteParams{ctx, articleID, tagIDs},
	}
	mmDelete.expectations = append(mmDelete.expectations, expectation)
	return expectation
}

// Then sets up IArticleTagRepository.Delete return parameters for the expectation previously defined by the When method
func (e *IArticleTagRepositoryMockDeleteExpectation) Then(err error) *IArticleTagRepositoryMock {
	e.results = &IArticleTagRepositoryMockDeleteResults{err}
	return e.mock
}

// Delete implements interfaces.IArticleTagRepository
func (mmDelete *IArticleTagRepositoryMock) Delete(ctx context.Context, articleID int, tagIDs []int) (err error) {
	mm_atomic.AddUint64(&mmDelete.beforeDeleteCounter, 1)
	defer mm_atomic.AddUint64(&mmDelete.afterDeleteCounter, 1)

	if mmDelete.inspectFuncDelete != nil {
		mmDelete.inspectFuncDelete(ctx, articleID, tagIDs)
	}

	mm_params := &IArticleTagRepositoryMockDeleteParams{ctx, articleID, tagIDs}

	// Record call args
	mmDelete.DeleteMock.mutex.Lock()
	mmDelete.DeleteMock.callArgs = append(mmDelete.DeleteMock.callArgs, mm_params)
	mmDelete.DeleteMock.mutex.Unlock()

	for _, e := range mmDelete.DeleteMock.expectations {
		if minimock.Equal(e.params, mm_params) {
			mm_atomic.AddUint64(&e.Counter, 1)
			return e.results.err
		}
	}

	if mmDelete.DeleteMock.defaultExpectation != nil {
		mm_atomic.AddUint64(&mmDelete.DeleteMock.defaultExpectation.Counter, 1)
		mm_want := mmDelete.DeleteMock.defaultExpectation.params
		mm_got := IArticleTagRepositoryMockDeleteParams{ctx, articleID, tagIDs}
		if mm_want != nil && !minimock.Equal(*mm_want, mm_got) {
			mmDelete.t.Errorf("IArticleTagRepositoryMock.Delete got unexpected parameters, want: %#v, got: %#v%s\n", *mm_want, mm_got, minimock.Diff(*mm_want, mm_got))
		}

		mm_results := mmDelete.DeleteMock.defaultExpectation.results
		if mm_results == nil {
			mmDelete.t.Fatal("No results are set for the IArticleTagRepositoryMock.Delete")
		}
		return (*mm_results).err
	}
	if mmDelete.funcDelete != nil {
		return mmDelete.funcDelete(ctx, articleID, tagIDs)
	}
	mmDelete.t.Fatalf("Unexpected call to IArticleTagRepositoryMock.Delete. %v %v %v", ctx, articleID, tagIDs)
	return
}

// DeleteAfterCounter returns a count of finished IArticleTagRepositoryMock.Delete invocations
func (mmDelete *IArticleTagRepositoryMock) DeleteAfterCounter() uint64 {
	return mm_atomic.LoadUint64(&mmDelete.afterDeleteCounter)
}

// DeleteBeforeCounter returns a count of IArticleTagRepositoryMock.Delete invocations
func (mmDelete *IArticleTagRepositoryMock) DeleteBeforeCounter() uint64 {
	return mm_atomic.LoadUint64(&mmDelete.beforeDeleteCounter)
}

// Calls returns a list of arguments used in each call to IArticleTagRepositoryMock.Delete.
// The list is in the same order as the calls were made (i.e. recent calls have a higher index)
func (mmDelete *mIArticleTagRepositoryMockDelete) Calls() []*IArticleTagRepositoryMockDeleteParams {
	mmDelete.mutex.RLock()

	argCopy := make([]*IArticleTagRepositoryMockDeleteParams, len(mmDelete.callArgs))
	copy(argCopy, mmDelete.callArgs)

	mmDelete.mutex.RUnlock()

	return argCopy
}

// MinimockDeleteDone returns true if the count of the Delete invocations corresponds
// the number of defined expectations
func (m *IArticleTagRepositoryMock) MinimockDeleteDone() bool {
	for _, e := range m.DeleteMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			return false
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.DeleteMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterDeleteCounter) < 1 {
		return false
	}
	// if func was set then invocations count should be greater than zero
	if m.funcDelete != nil && mm_atomic.LoadUint64(&m.afterDeleteCounter) < 1 {
		return false
	}
	return true
}

// MinimockDeleteInspect logs each unmet expectation
func (m *IArticleTagRepositoryMock) MinimockDeleteInspect() {
	for _, e := range m.DeleteMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			m.t.Errorf("Expected call to IArticleTagRepositoryMock.Delete with params: %#v", *e.params)
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.DeleteMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterDeleteCounter) < 1 {
		if m.DeleteMock.defaultExpectation.params == nil {
			m.t.Error("Expected call to IArticleTagRepositoryMock.Delete")
		} else {
			m.t.Errorf("Expected call to IArticleTagRepositoryMock.Delete with params: %#v", *m.DeleteMock.defaultExpectation.params)
		}
	}
	// if func was set then invocations count should be greater than zero
	if m.funcDelete != nil && mm_atomic.LoadUint64(&m.afterDeleteCounter) < 1 {
		m.t.Error("Expected call to IArticleTagRepositoryMock.Delete")
	}
}

type mIArticleTagRepositoryMockDeleteByArticleID struct {
	mock               *IArticleTagRepositoryMock
	defaultExpectation *IArticleTagRepositoryMockDeleteByArticleIDExpectation
	expectations       []*IArticleTagRepositoryMockDeleteByArticleIDExpectation

	callArgs []*IArticleTagRepositoryMockDeleteByArticleIDParams
	mutex    sync.RWMutex
}

// IArticleTagRepositoryMockDeleteByArticleIDExpectation specifies expectation struct of the IArticleTagRepository.DeleteByArticleID
type IArticleTagRepositoryMockDeleteByArticleIDExpectation struct {
	mock    *IArticleTagRepositoryMock
	params  *IArticleTagRepositoryMockDeleteByArticleIDParams
	results *IArticleTagRepositoryMockDeleteByArticleIDResults
	Counter uint64
}

// IArticleTagRepositoryMockDeleteByArticleIDParams contains parameters of the IArticleTagRepository.DeleteByArticleID
type IArticleTagRepositoryMockDeleteByArticleIDParams struct {
	ctx       context.Context
	articleID int
}

// IArticleTagRepositoryMockDeleteByArticleIDResults contains results of the IArticleTagRepository.DeleteByArticleID
type IArticleTagRepositoryMockDeleteByArticleIDResults struct {
	err error
}

// Expect sets up expected params for IArticleTagRepository.DeleteByArticleID
func (mmDeleteByArticleID *mIArticleTagRepositoryMockDeleteByArticleID) Expect(ctx context.Context, articleID int) *mIArticleTagRepositoryMockDeleteByArticleID {
	if mmDeleteByArticleID.mock.funcDeleteByArticleID != nil {
		mmDeleteByArticleID.mock.t.Fatalf("IArticleTagRepositoryMock.DeleteByArticleID mock is already set by Set")
	}

	if mmDeleteByArticleID.defaultExpectation == nil {
		mmDeleteByArticleID.defaultExpectation = &IArticleTagRepositoryMockDeleteByArticleIDExpectation{}
	}

	mmDeleteByArticleID.defaultExpectation.params = &IArticleTagRepositoryMockDeleteByArticleIDParams{ctx, articleID}
	for _, e := range mmDeleteByArticleID.expectations {
		if minimock.Equal(e.params, mmDeleteByArticleID.defaultExpectation.params) {
			mmDeleteByArticleID.mock.t.Fatalf("Expectation set by When has same params: %#v", *mmDeleteByArticleID.defaultExpectation.params)
		}
	}

	return mmDeleteByArticleID
}

// Inspect accepts an inspector function that has same arguments as the IArticleTagRepository.DeleteByArticleID
func (mmDeleteByArticleID *mIArticleTagRepositoryMockDeleteByArticleID) Inspect(f func(ctx context.Context, articleID int)) *mIArticleTagRepositoryMockDeleteByArticleID {
	if mmDeleteByArticleID.mock.inspectFuncDeleteByArticleID != nil {
		mmDeleteByArticleID.mock.t.Fatalf("Inspect function is already set for IArticleTagRepositoryMock.DeleteByArticleID")
	}

	mmDeleteByArticleID.mock.inspectFuncDeleteByArticleID = f

	return mmDeleteByArticleID
}

// Return sets up results that will be returned by IArticleTagRepository.DeleteByArticleID
func (mmDeleteByArticleID *mIArticleTagRepositoryMockDeleteByArticleID) Return(err error) *IArticleTagRepositoryMock {
	if mmDeleteByArticleID.mock.funcDeleteByArticleID != nil {
		mmDeleteByArticleID.mock.t.Fatalf("IArticleTagRepositoryMock.DeleteByArticleID mock is already set by Set")
	}

	if mmDeleteByArticleID.defaultExpectation == nil {
		mmDeleteByArticleID.defaultExpectation = &IArticleTagRepositoryMockDeleteByArticleIDExpectation{mock: mmDeleteByArticleID.mock}
	}
	mmDeleteByArticleID.defaultExpectation.results = &IArticleTagRepositoryMockDeleteByArticleIDResults{err}
	return mmDeleteByArticleID.mock
}

//Set uses given function f to mock the IArticleTagRepository.DeleteByArticleID method
func (mmDeleteByArticleID *mIArticleTagRepositoryMockDeleteByArticleID) Set(f func(ctx context.Context, articleID int) (err error)) *IArticleTagRepositoryMock {
	if mmDeleteByArticleID.defaultExpectation != nil {
		mmDeleteByArticleID.mock.t.Fatalf("Default expectation is already set for the IArticleTagRepository.DeleteByArticleID method")
	}

	if len(mmDeleteByArticleID.expectations) > 0 {
		mmDeleteByArticleID.mock.t.Fatalf("Some expectations are already set for the IArticleTagRepository.DeleteByArticleID method")
	}

	mmDeleteByArticleID.mock.funcDeleteByArticleID = f
	return mmDeleteByArticleID.mock
}

// When sets expectation for the IArticleTagRepository.DeleteByArticleID which will trigger the result defined by the following
// Then helper
func (mmDeleteByArticleID *mIArticleTagRepositoryMockDeleteByArticleID) When(ctx context.Context, articleID int) *IArticleTagRepositoryMockDeleteByArticleIDExpectation {
	if mmDeleteByArticleID.mock.funcDeleteByArticleID != nil {
		mmDeleteByArticleID.mock.t.Fatalf("IArticleTagRepositoryMock.DeleteByArticleID mock is already set by Set")
	}

	expectation := &IArticleTagRepositoryMockDeleteByArticleIDExpectation{
		mock:   mmDeleteByArticleID.mock,
		params: &IArticleTagRepositoryMockDeleteByArticleIDParams{ctx, articleID},
	}
	mmDeleteByArticleID.expectations = append(mmDeleteByArticleID.expectations, expectation)
	return expectation
}

// Then sets up IArticleTagRepository.DeleteByArticleID return parameters for the expectation previously defined by the When method
func (e *IArticleTagRepositoryMockDeleteByArticleIDExpectation) Then(err error) *IArticleTagRepositoryMock {
	e.results = &IArticleTagRepositoryMockDeleteByArticleIDResults{err}
	return e.mock
}

// DeleteByArticleID implements interfaces.IArticleTagRepository
func (mmDeleteByArticleID *IArticleTagRepositoryMock) DeleteByArticleID(ctx context.Context, articleID int) (err error) {
	mm_atomic.AddUint64(&mmDeleteByArticleID.beforeDeleteByArticleIDCounter, 1)
	defer mm_atomic.AddUint64(&mmDeleteByArticleID.afterDeleteByArticleIDCounter, 1)

	if mmDeleteByArticleID.inspectFuncDeleteByArticleID != nil {
		mmDeleteByArticleID.inspectFuncDeleteByArticleID(ctx, articleID)
	}

	mm_params := &IArticleTagRepositoryMockDeleteByArticleIDParams{ctx, articleID}

	// Record call args
	mmDeleteByArticleID.DeleteByArticleIDMock.mutex.Lock()
	mmDeleteByArticleID.DeleteByArticleIDMock.callArgs = append(mmDeleteByArticleID.DeleteByArticleIDMock.callArgs, mm_params)
	mmDeleteByArticleID.DeleteByArticleIDMock.mutex.Unlock()

	for _, e := range mmDeleteByArticleID.DeleteByArticleIDMock.expectations {
		if minimock.Equal(e.params, mm_params) {
			mm_atomic.AddUint64(&e.Counter, 1)
			return e.results.err
		}
	}

	if mmDeleteByArticleID.DeleteByArticleIDMock.defaultExpectation != nil {
		mm_atomic.AddUint64(&mmDeleteByArticleID.DeleteByArticleIDMock.defaultExpectation.Counter, 1)
		mm_want := mmDeleteByArticleID.DeleteByArticleIDMock.defaultExpectation.params
		mm_got := IArticleTagRepositoryMockDeleteByArticleIDParams{ctx, articleID}
		if mm_want != nil && !minimock.Equal(*mm_want, mm_got) {
			mmDeleteByArticleID.t.Errorf("IArticleTagRepositoryMock.DeleteByArticleID got unexpected parameters, want: %#v, got: %#v%s\n", *mm_want, mm_got, minimock.Diff(*mm_want, mm_got))
		}

		mm_results := mmDeleteByArticleID.DeleteByArticleIDMock.defaultExpectation.results
		if mm_results == nil {
			mmDeleteByArticleID.t.Fatal("No results are set for the IArticleTagRepositoryMock.DeleteByArticleID")
		}
		return (*mm_results).err
	}
	if mmDeleteByArticleID.funcDeleteByArticleID != nil {
		return mmDeleteByArticleID.funcDeleteByArticleID(ctx, articleID)
	}
	mmDeleteByArticleID.t.Fatalf("Unexpected call to IArticleTagRepositoryMock.DeleteByArticleID. %v %v", ctx, articleID)
	return
}

// DeleteByArticleIDAfterCounter returns a count of finished IArticleTagRepositoryMock.DeleteByArticleID invocations
func (mmDeleteByArticleID *IArticleTagRepositoryMock) DeleteByArticleIDAfterCounter() uint64 {
	return mm_atomic.LoadUint64(&mmDeleteByArticleID.afterDeleteByArticleIDCounter)
}

// DeleteByArticleIDBeforeCounter returns a count of IArticleTagRepositoryMock.DeleteByArticleID invocations
func (mmDeleteByArticleID *IArticleTagRepositoryMock) DeleteByArticleIDBeforeCounter() uint64 {
	return mm_atomic.LoadUint64(&mmDeleteByArticleID.beforeDeleteByArticleIDCounter)
}

// Calls returns a list of arguments used in each call to IArticleTagRepositoryMock.DeleteByArticleID.
// The list is in the same order as the calls were made (i.e. recent calls have a higher index)
func (mmDeleteByArticleID *mIArticleTagRepositoryMockDeleteByArticleID) Calls() []*IArticleTagRepositoryMockDeleteByArticleIDParams {
	mmDeleteByArticleID.mutex.RLock()

	argCopy := make([]*IArticleTagRepositoryMockDeleteByArticleIDParams, len(mmDeleteByArticleID.callArgs))
	copy(argCopy, mmDeleteByArticleID.callArgs)

	mmDeleteByArticleID.mutex.RUnlock()

	return argCopy
}

// MinimockDeleteByArticleIDDone returns true if the count of the DeleteByArticleID invocations corresponds
// the number of defined expectations
func (m *IArticleTagRepositoryMock) MinimockDeleteByArticleIDDone() bool {
	for _, e := range m.DeleteByArticleIDMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			return false
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.DeleteByArticleIDMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterDeleteByArticleIDCounter) < 1 {
		return false
	}
	// if func was set then invocations count should be greater than zero
	if m.funcDeleteByArticleID != nil && mm_atomic.LoadUint64(&m.afterDeleteByArticleIDCounter) < 1 {
		return false
	}
	return true
}

// MinimockDeleteByArticleIDInspect logs each unmet expectation
func (m *IArticleTagRepositoryMock) MinimockDeleteByArticleIDInspect() {
	for _, e := range m.DeleteByArticleIDMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			m.t.Errorf("Expected call to IArticleTagRepositoryMock.DeleteByArticleID with params: %#v", *e.params)
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.DeleteByArticleIDMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterDeleteByArticleIDCounter) < 1 {
		if m.DeleteByArticleIDMock.defaultExpectation.params == nil {
			m.t.Error("Expected call to IArticleTagRepositoryMock.DeleteByArticleID")
		} else {
			m.t.Errorf("Expected call to IArticleTagRepositoryMock.DeleteByArticleID with params: %#v", *m.DeleteByArticleIDMock.defaultExpectation.params)
		}
	}
	// if func was set then invocations count should be greater than zero
	if m.funcDeleteByArticleID != nil && mm_atomic.LoadUint64(&m.afterDeleteByArticleIDCounter) < 1 {
		m.t.Error("Expected call to IArticleTagRepositoryMock.DeleteByArticleID")
	}
}

// MinimockFinish checks that all mocked methods have been called the expected number of times
func (m *IArticleTagRepositoryMock) MinimockFinish() {
	if !m.minimockDone() {
		m.MinimockAddInspect()

		m.MinimockDeleteInspect()

		m.MinimockDeleteByArticleIDInspect()
		m.t.FailNow()
	}
}

// MinimockWait waits for all mocked methods to be called the expected number of times
func (m *IArticleTagRepositoryMock) MinimockWait(timeout mm_time.Duration) {
	timeoutCh := mm_time.After(timeout)
	for {
		if m.minimockDone() {
			return
		}
		select {
		case <-timeoutCh:
			m.MinimockFinish()
			return
		case <-mm_time.After(10 * mm_time.Millisecond):
		}
	}
}

func (m *IArticleTagRepositoryMock) minimockDone() bool {
	done := true
	return done &&
		m.MinimockAddDone() &&
		m.MinimockDeleteDone() &&
		m.MinimockDeleteByArticleIDDone()
}
